#!/usr/bin/env python
# -*- coding: utf-8 -*-
from __future__ import print_function

import json
import urllib
import pamela as pam

__USERNAME = 'Username'
__PASSWORD = 'Password'
__EMPTY_USER = {__USERNAME: '', __PASSWORD: '', 'Role': '', 'Id': ''}


def auth(cmd):
    try:
        username = cmd[__USERNAME]
        password = urllib.unquote(cmd[__PASSWORD]).decode('utf8')
        pam.authenticate(username, password)
        return {'Id': 1, __USERNAME: username, 'Role': 1}
    except:
        return __EMPTY_USER


def check_auth_shim(sink, username, password):
    src = json.dumps({__USERNAME: username, __PASSWORD: password, 'Role': '', 'Id': ''}).encode('utf-8')
    try:
        resp = sink(src)
    except Exception as ex:
        print(ex)
    else:
        try:
            msg = json.loads(resp)
            if msg['Username'] == username:
                print('Successful authentication %s %s' % (username, password))
            else:
                print('Unsuccessful authentication %s %s' % (username, password))
        except Exception as ex:
            print(ex)
            print(resp)
